#include <math.h>
#include <vector>
#include <iostream>
#include <sstream>
#include <curl/curl.h>
#include <string>

#include "histogram.h"
#include "text.h"
#include "svg.h"


using namespace std;

struct Input {
    vector<double> numbers;
    size_t bin_count{};
    float n;
};

Input
input_data(istream& in,bool prompt) {
    string a, b, c;
    if(prompt== true){
    a = "Enter number count:";
    b = "Enter numbers:";
    c = "Enter bin count:";
    }
    size_t number_count;
    cerr << a;
    in >> number_count;

    Input on;
    on.numbers.resize(number_count);
    for (size_t i = 0; i < number_count; i++) {
        cerr << b << i+1 << ": ";
        in >> on.numbers[i];}
    cerr << c;
    in >> on.bin_count;

    on.n = 0;
    if (on.bin_count==0){
        on.bin_count = sqrt(number_count);
        on.n = 1;
        if (on.bin_count > 25){
            on.bin_count = 1 + log2(number_count);
            on.n = 2;}}

    return on;
}

size_t
write_data(void* items, size_t item_size, size_t item_count, void* ctx) {
    size_t data_size = item_size * item_count;
    stringstream* buffer = reinterpret_cast<stringstream*>(ctx);
    buffer->write(reinterpret_cast<const char*>(items), data_size);
    return data_size;
}

Input
download(const string& address) {
    stringstream buffer;
    CURL* curl = curl_easy_init();
    if(curl) {
        CURLcode res;


        curl_easy_setopt(curl, CURLOPT_URL, address.c_str());
        curl_easy_setopt(curl, CURLOPT_WRITEFUNCTION, write_data);
        curl_easy_setopt(curl, CURLOPT_WRITEDATA, &buffer);

        res = curl_easy_perform(curl);
        if(res != CURLE_OK){
            cerr << curl_easy_strerror(res);
            exit(1);}
        curl_easy_cleanup(curl);}
    return input_data(buffer, false);
}


int main(int argc, char* argv[]){
    Input input;
    if (argc > 1) {
        input = download(argv[1]);}
    else {
        input = input_data(cin, true);}

    const auto bins = make_histogram(input);
    show_histogram_svg(bins);
return 0;
}
